Description

Possible goals

* Rearrange BornAgain fit machinery so it could support external minimizers (i.e. Imfit).
* Make switch between external/internal minimizers as painless as possible.
¢ Provide the possibility to use our internal minimizer for BornAgain unrelated tasks.

Ideally, BornAgain own minimization engine should not have any access to address space inside a Simulation.
Values of parameters to minimize should be propagated from the minimizer to a kind of SimulationBuilder via dictionaries.

Within this item consider the following:

¢ Expose MinimizerKernel to Python.

Make FitSuite interface look similar to Imfit.

Consider dropping of translation mechanism in GUI in the favor of SimulationBuilder leaving in GUI.
Consider dropping of IParameterized::registerParameter machinery, onChange() signaling etc.

Connected issues

¢ #2018 Revise RealDataltem and the way it handles cropped experimental data.
e #2014 Provide uniform access interface for simulation/fitting results.

e #2011 API changes to access the simulation results.

e #1675 Get rid of ctypes.addressof in PySampleBuilder.

Other related issue

e #1918 Revise IHistogram class family.

® #1754 Investigate fitting with Log-Likelihood.

e #1704 Revise chi squared module.

e #1495 GUI: extend GUISuite functional test machinery with standard fits.

e #1494 GUI: Implement export of fitting setup to python script.

e #1493 GUI: Implement tranform from domain for fitting objects.

e #1415 onChange() should invalidate cache, and not immediately execute precompute().
e #1210 GSLLMA minimizer sometimes doesn't respect fit parameter limits attribute.

e #587 Investigate objective function alternatives.

History

#1 - 12 Apr 2018 17:06 - pospelov

- Assignee set to pospelov

#2 - 18 Apr 2018 09:07 - pospelov

Summary:

Suggested goals for the future refactoring:
e Get rid from bulky FitSuite/SampleBuilder part of the minimizer machinery.
e Provide interface which looks "more or less" like in other minimizers.
¢ Make possible the usage of external minimizers.

* Promote user experiments in the direction leading away from BornAgain fitting kernel.

Steps for this release:
1) Make BornAgain minimizer interface look similar to Imfit.
It will consist of three thin classes: Parameter, Parameters and Minimizer

¢ Parameter class
o Describes single fit parameter, looks very much as current IFitParameter.
o It's Python constructor (or counterpart) should look like Imfit.Parameter.

e Parameters class
o Just a container with all fit parameters.
o Capable of generating dictionary (name : value) to feed user FCN functions.

e Minimizer class
o Internally it will contain our current FitKernel.
o It will accept user fcn function (or Python callback).
o FCN function should accept simple parameter dictionary (name : current_value) and allways return vector of residuals.
o Minimizer will either calculate chi2 from FCN residuals, or use residuals directly.

parameters = Parameters()
parameters.add("length", 5.0, RealLimits.limited())

minimizer = Minimizer()
minimizer.setOptions("Minuit2", "Migrad", "maxlterations=5")
minimizer.minimize(parameters, fcn)

2) Switch FitSuite to the new Minimizer class.

o FitParameter will remain the same as it is now, but will have no relations to the refactored Minimizer's Parameter.

e FitSuite interface will remain the same for the moment (to keep GUI alive).

¢ FitKernel will be removed from class members.

¢ FitSuite will have an FCN function on board, whose task will be to propagate current parameter dictionary to old FitParameter to trigger linked
parameter mechanism.

3) Remove FitSuite from all Python examples/tutorials.

* Python examples should rely on our new Minimizer and/or Imfit.
e Remove all description of linked parameters, FitSuite and SampleBuilder from tutorials.

Steps for the next release:

Implement FCN function in GUI and use refactored Minimizer instead of FitSuite.

Eliminate all traces of translation mechanism.

Provide ExportToPython in GUI.

Provide ExportToPython in GUI for fitting jobs.

In princile, IParameterized, ParameterPool, SampleBuilder in Python, etc are getting useless and can be removed.
#3 - 20 Apr 2018 14:34 - pospelov

- Status changed from Sprint to Resolved
